/* ... "FEBEX_control.h" ...  FEBEX specific definitions ... */

#ifndef _FEBEXCONTROL_H
#define _FEBEXCONTROL_H

#include <unistd.h>

#include "readout.h"
#include "FEBEX_readout.h"

#define OUTPUT_BUFFER_LENGTH 64*1024    /* default size 64 Kbytes  */

#define DACQ_INT_LEVELS 0
#define DACQ_INT_BASE 0    /* not used  */

int FEBEXInit = 0;


void FEBEX_init() {   /* DACQ_setup */
    uint8_t rc;
    
    printf ("FEBEX_init\n");

    if (FEBEXInit) return;
    
    (void) FEBEX_init_connection();
 
    FEBEXInit++;
}

void FEBEX_stop()  {
  
    if (FEBEX_Data_Out_Enable == 1) {
      
       if (FEBEX_DataOutHandle != 0) {fclose (FEBEX_DataOutHandle); FEBEX_DataOutHandle = 0;}

    }   
   
    printf ("FEBEX state now Stopped\n");
}

void FEBEX_go() {
  
   (void) febex_go_connection ();
    
    printf ("FEBEX state now Going\n");
}

void FEBEX_reset() {
  
  FEBEX_stop();
  
  if (FEBEXInit > 0) {
    (void) FEBEX_term_connection();
    FEBEXInit = 0;
  }  

  printf ("FEBEX state now Reset\n");

}

void FEBEX_init_connection () {
  
    (void) febex_init_connection();
    
    printf ("Completed FEBEX_init_connection\n");
  
}

void FEBEX_term_connection() {
 
    (void) febex_term_connection();  
}

#endif



