
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <errno.h>
#include <unistd.h>

#include <time.h>


void Usage(char *progname) {
    printf("Usage\n%s \n",progname);
    exit(16);
}
        
int main(int argc, char **argv) {
 
    struct timeval Time;

    FILE *OutStream;
    char *FileName= (char*)"fin";
    char fname[32];
    int verbose=0;
    int h, i, j, k;
    
    int NumBlocks = 2;
    int NumItems = 32;
    int NumCh = 16;
    
    unsigned short T5548 = 0;
    unsigned short T4732 = 0;
    unsigned short T3116 = 0;
    unsigned short T1500 = 0;
    unsigned short T6356 = 0;
    
    unsigned short UEnergy3116 = 0;
    unsigned short UEnergy1500 = 0;
    
    unsigned int ChID=0;
    unsigned int ModID=0;
    unsigned int SfpID=0;
    unsigned int TrigID = 1;
    unsigned int PU=0;
    
    unsigned int Counter = 0;    /* &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& */
    unsigned int UEnergy = 0;     /* &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& */
    unsigned long long TimeStamp = 0;   /* &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& */
    
    
    int BufferSize=64*1024;
    
    unsigned int Buffer[16*1024];
    unsigned int* BufferPtr32;
    unsigned short* BufferPtr16;
    int rc;
    
    int Data32;
    short Data16;
    
    int totalsize;
    int blocksize;
    int len = 0;

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(argv[i][1]) {
                    case 'f':
                        FileName = argv[++i];
                        break;
		    case 'b':
			NumBlocks = atoi(argv[++i]);
			break;
		    case 'i':
			NumItems = atoi(argv[++i]);
			break;
		    case 'm':
			ModID = atoi(argv[++i]);
			break;
		    case 's':
			SfpID = atoi(argv[++i]);
			break;			
		    case 'c':
			NumCh = atoi(argv[++i]);
			break;
                    case 'v':
                        verbose = 1;
                        break;
                    default:
                        Usage(argv[0]);
                }
            }
            else
                Usage(argv[0]);
        }
    }
    
    
  //    check the file name

         sprintf(fname,"%s.dat",FileName);
         OutStream = fopen(fname,"w");
         if (OutStream == NULL) {
           printf ("Unable to connect to data file %s\n",fname);
           exit(16);
         }
 
         
       for (k=0; k < NumBlocks; k++) {
    
        BufferPtr32 = (unsigned int*) &Buffer[0];
	BufferPtr16 = (unsigned short*) &Buffer[0];
	
	  totalsize = 0;
		 
	
//    Sum channel  
         
	 Data32 = (0xff << 24) | ((ModID & 0xff) << 16) | ((SfpID & 3) << 12) | ((TrigID & 15) << 8) | 0x34;
         *BufferPtr32++ = Data32;
	 *BufferPtr32++ = 0;
	   
	   len = 0;
	   
	   
//      data items
	  
	   
	 for (i=0; i<NumCh; i++) {
		 
           gettimeofday(&Time, NULL); 
	   TimeStamp = (Time.tv_sec * 1000000) + Time.tv_usec;   /*  units usecs */
	   
	   T6356 = (unsigned short) (TimeStamp >> 56) & 0xff;
	   T5548 = (unsigned short) (TimeStamp >> 48) & 0xff;
	   T4732 = (unsigned short) (TimeStamp >> 32) & 0x0ffff;
	   T3116 = (unsigned short) (TimeStamp >> 16) & 0x0ffff;
	   T1500 = (unsigned short) TimeStamp & 0x0ffff;
	   
	   UEnergy3116 = 0;
	   UEnergy1500 = T1500 & 0x0fff;
		 
	    ChID = i & 15;
	        
            BufferPtr16 = (unsigned short*) BufferPtr32;

	    *BufferPtr16++ = T4732;    /*  W1  */
            *BufferPtr16++ = (ChID << 12) | (PU << 8) | T5548;   /* W0 */

	    BufferPtr32++;
	    
	    *BufferPtr16++ = T1500;    /*  W3  */
	    *BufferPtr16++ = T3116;    /*  W2  */
	    BufferPtr32++;
	    
	    *BufferPtr16++ = UEnergy1500;    /*  W5   */
	    *BufferPtr16++ = UEnergy3116;    /*  W4   */
	    BufferPtr32++;

	    
	    printf ("%d %d 0x%llx  0x%lx  0x%lx  0x%lx  0x%lx  0x%x  0x%x\n", i, ChID, TimeStamp, T5548, T4732, T3116, T1500, UEnergy3116, UEnergy1500);

	    
	    len = len + (6*2);
	    
	    
           }    /*  end of for (i=0; j<NumCh; i++)    */
	 
	     Buffer[1] = len;   /*  sum channel length  */
	  
	  	 totalsize = totalsize + len + 8;
		 
		 
	 printf("totalsize = 0x%x %d\n",totalsize,totalsize);
	 
	    rc = fwrite(&totalsize, 1, sizeof (totalsize), OutStream);
	    
	    rc = fwrite(&Buffer[0], 1, totalsize, OutStream);
	 
	 }    /* end of (k=0; k<NumBlocks; k++)    */
	 
	 

	    
	 
         
         fclose(OutStream);
	 


}
