
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <errno.h>
#include <unistd.h>

#include <time.h>


void Usage(char *progname) {
    printf("Usage\n%s \n",progname);
    exit(16);
}
        
int main(int argc, char **argv) {
 
    struct timeval Time;

    FILE *OutStream;
    char *FileName= (char*)"f0";
    char fname[32];
    int verbose=0;
    int i, j, k, l;
    
    int NumBlocks = 2;
    int NumItems = 32;
    int NumCh = 16;
    
    unsigned int ChID=0;
    unsigned int ModID=0;
    unsigned int SfpID=0;
    unsigned int TrigID = 1;
    
    unsigned int EvCounter = 0;    /* &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& */
    unsigned int Energy = 0;     /* &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&  */
    unsigned long TimeStamp = 0;   /* &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& */
    
    int BufferSize=64*1024;
    
    unsigned int Buffer[16*1024];
    unsigned int* BufferPtr32;
    unsigned short* BufferPtr16;
    int rc;
    
    int Data32;
    short Data16;
    
    int TraceLength = 128;
    
    int totalsize;
    int blocksize;
    int len = 0;

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(argv[i][1]) {
                    case 'f':
                        FileName = argv[++i];
                        break;
		    case 'b':
			NumBlocks = atoi(argv[++i]);
			break;
		    case 'i':
			NumItems = atoi(argv[++i]);
			break;
		    case 'm':
			ModID = atoi(argv[++i]);
			break;
		    case 's':
			SfpID = atoi(argv[++i]);
			break;			
		    case 'c':
			NumCh = atoi(argv[++i]);
			break;
                    case 'v':
                        verbose = 1;
                        break;
                    default:
                        Usage(argv[0]);
                }
            }
            else
                Usage(argv[0]);
        }
    }
    
    
  //    check the file name

         sprintf(fname,"%s.dat",FileName);
         OutStream = fopen(fname,"w");
         if (OutStream == NULL) {
           printf ("Unable to connect to data file %s\n",fname);
           exit(16);
         }
 
         
       for (k=0; k < NumBlocks; k++) {
    
        BufferPtr32 = (unsigned int*) &Buffer[0];
	BufferPtr16 = (unsigned short*) &Buffer[0];
	
	 EvCounter++;
	 totalsize = 0;
	
//    Sum channel  
         
	 Data32 = (0xff << 24) | ((ModID & 0xff) << 16) | ((SfpID & 3) << 12) | ((TrigID & 15) << 8) | 0x34;
         *BufferPtr32++ = Data32;
	 *BufferPtr32++ = 0;        /*  sum channel length */
	   
	   len = 0;
	   
//      trace channels
	   
	 for (i=0; i<NumCh; i++) {
		 
           gettimeofday(&Time, NULL); 
	   TimeStamp = (Time.tv_sec * 1000000) + Time.tv_usec;   /*  units usecs */
		 
	    ChID = i & 15;
	  
	     Data32 = (0x0 << 28) | (ChID << 24) | ((ModID & 0xff) << 16) | ((SfpID & 3) << 12) | ((TrigID & 15) << 8) | 0x34;
            *BufferPtr32++ = Data32;
	    
	    *BufferPtr32++ = (TraceLength * 2) + 8;
	    
	     Data32 = (0xa << 28) | (ChID << 24) | (0x23 << 16) | EvCounter;
	    *BufferPtr32++ = Data32;
	    
	    for (l=0; l<TraceLength; l+=2) {          /*  generate a trace buffer  */
	        *BufferPtr32++ = (l << 16) | (l + 1);
	    }
	    
	     Data32 = (0xb << 28) | (ChID << 24) | (0x23 << 16) | EvCounter;
	    *BufferPtr32++ = Data32;	
	    
	    len = len + (TraceLength * 2) + 16;
	    
          }    /*  end of for (i=0; j<NumCh; i++)    */
           
	  
	  	 totalsize = totalsize + len + 8;
		 
		 
//	 printf("totalsize = 0x%x %d\n",totalsize,totalsize);
	 
	    rc = fwrite(&totalsize, 1, sizeof (totalsize), OutStream);
	    
	    rc = fwrite(&Buffer[0], 1, totalsize, OutStream);
	 
	 }    /* end of (k=0; k<NumBlocks; k++)    */
	 
         fclose(OutStream);
	 


}
