
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <errno.h>
#include <unistd.h>

#include <time.h>


void Usage(char *progname) {
    printf("Usage\n%s \n",progname);
    exit(16);
}
        
int main(int argc, char **argv) {
 
    struct timeval Time;

    FILE *OutStream;
    char *FileName= (char*)"f0";
    char fname[32];
    int verbose=0;
    int i, j, k;
    
    int NumBlocks = 1;
    int NumItems = 1;
    short ChNum = 15;
    
    unsigned short ChID = 0;
    unsigned short T0007 = 1;
    unsigned short T0823 = 2;
    unsigned short T2439 = 3;
    unsigned short T4055 = 4;
    unsigned short E0015 = 0;
    unsigned short E1631 = 0;
    
    float Energy;
    unsigned long TimeStamp;
    
    int BufferSize=64*1024;
    
    unsigned int Buffer[16*1024];
    unsigned int* BufferPtr32;
    unsigned short* BufferPtr16;
    float * BufferPtrf;
    unsigned int* BufferPtrh;
    int rc;
    
    int totalsize;
    int blocksize;
    int len = 0;

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(argv[i][1]) {
                    case 'f':
                        FileName = argv[++i];
                        break;
		    case 'b':
			NumBlocks = atoi(argv[++i]);
			break;
		    case 'i':
			NumItems = atoi(argv[++i]);
			break;
		    case 'c':
			ChNum = atoi(argv[++i]);
			break;
                    case 'v':
                        verbose = 1;
                        break;
                    default:
                        Usage(argv[0]);
                }
            }
            else
                Usage(argv[0]);
        }
    }
    
    
  //    check the file name

         sprintf(fname,"%s.dat",FileName);
         OutStream = fopen(fname,"w");
         if (OutStream == NULL) {
           printf ("Unable to connect to data file %s\n",fname);
           exit(16);
         }
         
       for (k=0; k < NumBlocks; k++) {
    
        BufferPtr32 = (unsigned int*) &Buffer[0];
	BufferPtr16 = (unsigned short*) &Buffer[0];
	
	BufferPtrf  = (float *) &Buffer[0];
	
	 for (j=0; j < NumItems; j++) {
         
         *BufferPtr32++ = 0xff000134;
	 
	 BufferPtrh = (unsigned int*) BufferPtr32;
	 *BufferPtr32++ = 0;
	 
	   BufferPtr16 = (unsigned short*) BufferPtr32;
	   BufferPtrf  = (float *) BufferPtr32;
	
           len = 0;
	   Energy = 100.2345;
	 
	 for (i=0; i<16; i++) {
		 
           gettimeofday(&Time, NULL);  
	   
	   TimeStamp = Time.tv_usec;
	   T0007 = TimeStamp & 0xff;
	   T0823 = (TimeStamp >> 8) & 0x0ffff;
	   T2439 = (TimeStamp >> 24) & 0x0ffff;
	   T4055 = (TimeStamp >> 40) & 0x0ffff;
		 
	    ChID = i;
            Energy++;
	    
//	    printf ("%d  %x %x  %x  %x  %x  %x  %f\n", i, ChID, TimeStamp, T0007, T0823, T2439, T4055, Energy);
	    
            *BufferPtr16++ = (ChID << 12) + T0007;
	    *BufferPtr16++ = T0823;
	    BufferPtr32++;
	    BufferPtrf++;
	    
	    *BufferPtr16++ = T2439;
	    *BufferPtr16++ = T4055;
	    BufferPtr32++;
	    BufferPtrf++;
	   
	    *BufferPtrf = Energy;
	    BufferPtrf++;
	    BufferPtr32++;
	    BufferPtr16+=2;
	    
	    len=len+12;
	 
	 }
	 
	 totalsize = 12 + len;
	 
	 *BufferPtrh = 8 + len;
	 
	    rc = fwrite(&totalsize, 1, sizeof (totalsize), OutStream);
	    
	    rc = fwrite(&Buffer[0], 1, totalsize, OutStream);
	    

	 }
	 
       }
	 
         
         fclose(OutStream);
	 


}
