
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <errno.h>
#include <unistd.h>

#include <time.h>


void Usage(char *progname) {
    printf("Usage\n%s \n",progname);
    exit(16);
}
        
int main(int argc, char **argv) {
 
    struct timeval Time;

    FILE *OutStream;
    char *FileName= (char*)"f0";
    char fname[32];
    int verbose=0;
    int h, i, j, k;
    
    int NumBlocks = 2;
    int NumItems = 32;
    int NumCh = 16;
    
    unsigned int T0007 = 1;
    unsigned int T0823 = 2;
    unsigned int T2439 = 3;
    unsigned int T4055 = 4;
    unsigned int T0031 = 5;
    unsigned int T3247 = 6;
    
    unsigned int ChID=0;
    unsigned int ModID=1;
    unsigned int SfpID=2;
    unsigned int TrigID = 1;
    
    unsigned int EvCounter = 0;
    float Energy = 100.0;
    unsigned long TimeStamp = 0;
    
    int BufferSize=64*1024;
    
    unsigned int Buffer[16*1024];
    unsigned int* BufferPtr32;
    unsigned short* BufferPtr16;
    float * BufferPtrf;
    unsigned int* BufferPtrh;
    int rc;
    
    int Data32;
    short Data16;
    
    int totalsize;
    int blocksize;
    int len = 0;

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(argv[i][1]) {
                    case 'f':
                        FileName = argv[++i];
                        break;
		    case 'b':
			NumBlocks = atoi(argv[++i]);
			break;
		    case 'i':
			NumItems = atoi(argv[++i]);
			break;
		    case 'c':
			NumCh = atoi(argv[++i]);
			break;
                    case 'v':
                        verbose = 1;
                        break;
                    default:
                        Usage(argv[0]);
                }
            }
            else
                Usage(argv[0]);
        }
    }
    
    
  //    check the file name

         sprintf(fname,"%s.dat",FileName);
         OutStream = fopen(fname,"w");
         if (OutStream == NULL) {
           printf ("Unable to connect to data file %s\n",fname);
           exit(16);
         }
 
         
       for (k=0; k < NumBlocks; k++) {
    
        BufferPtr32 = (unsigned int*) &Buffer[0];
	BufferPtr16 = (unsigned short*) &Buffer[0];
	
	BufferPtrf  = (float *) &Buffer[0];
	
	  totalsize = 0;
		 
	
//    Sum channel  
         
	 Data32 = (0xff << 24) | ((ModID & 0xff) << 16) | ((SfpID & 3) << 12) | ((TrigID & 15) << 8) | 0x34;
         *BufferPtr32++ = Data32;
	 
	 BufferPtrh = (unsigned int*) BufferPtr32;
	 *BufferPtr32++ = 0;
	 
           BufferPtr16 = (unsigned short*) BufferPtr32;
	   BufferPtrf  = (float *) BufferPtr32;
	   
	   len = 0;
	   
	   
//      data items
	  
	   
	 for (i=0; i<NumItems; i++) {
		 
           gettimeofday(&Time, NULL);  
	   
	   TimeStamp = Time.tv_usec;
	   T0007 = TimeStamp & 0xff;
	   T0823 = (TimeStamp >> 8) & 0x0ffff;
	   T2439 = (TimeStamp >> 24) & 0x0ffff;
	   T4055 = (TimeStamp >> 40) & 0x0ffff;
		 
	    ChID = i & 15;
            Energy++;
	    
//	    printf ("%d  %x %x  %x  %x  %x  %x  %f\n", i, ChID, TimeStamp, T0007, T0823, T2439, T4055, Energy);
    
            BufferPtr16 = (unsigned short*) BufferPtr32;

            *BufferPtr16++ = (ChID << 12) | T0007;   /* W0 */
	    *BufferPtr16++ = T0823;    /*  W1  */
	    *BufferPtr16++ = T2439;    /*  W2  */
	    *BufferPtr16++ = T4055;    /*  W3  */
	    
	    BufferPtr32++;
	    BufferPtr32++;
	    
	    BufferPtrf  = (float *) BufferPtr32;
	    *BufferPtrf = Energy;
	    BufferPtr32++;
	    
	    
	    len = len + (3*4);
	    
	    
           }    /*  end of for (j=0; j<NumItems; j++)    */
           
           
           
 	   
//   16 trace channel buffers
	  
	   
	 for (i=0; i<NumCh; i++) {
		 
           gettimeofday(&Time, NULL);  
	   
	   TimeStamp = Time.tv_usec;
	   T0007 = TimeStamp & 0xff;
	   T0823 = (TimeStamp >> 8) & 0x0ffff;
	   T2439 = (TimeStamp >> 24) & 0x0ffff;
	   T4055 = (TimeStamp >> 40) & 0x0ffff;
		 
	    ChID = i & 15;
            Energy++;
	    EvCounter++;
	    
//	    printf ("%d  %x %x  %x  %x  %x  %x  %f\n", i, ChID, TimeStamp, T0007, T0823, T2439, T4055, Energy)
	 
	    Data32 = (ChID << 24) | ((ModID & 0xff) << 16) | ((SfpID & 3) << 12) | ((TrigID & 15) << 8) | 0x34;
	    *BufferPtr32++ = Data32;
	    
	    *BufferPtr32++ = (8 + 12);     /* item size */
	    
	    Data32 = (unsigned int ) (0xa << 28) | (ChID << 24) | (0x10 << 16) | EvCounter;
	    *BufferPtr32++ = Data32;
    
            BufferPtr16 = (unsigned short*) BufferPtr32;

            *BufferPtr16++ = (ChID << 12) | T0007;   /* W0 */
	    *BufferPtr16++ = T0823;    /*  W1  */
	    *BufferPtr16++ = T2439;    /*  W2  */
	    *BufferPtr16++ = T4055;    /*  W3  */
	    
	    BufferPtr32++;
	    BufferPtr32++;
	    
	    BufferPtrf  = (float *) BufferPtr32;
	    *BufferPtrf = Energy;
	    BufferPtr32++;
	    
	    Data32 = (unsigned int) (0xb << 28) | (ChID << 24) | (0x10 << 16) | EvCounter;
	    *BufferPtr32++ = Data32;
	    
	    len = len + (7*4);
	    
	 }    /*  end of for (i=0; i<NumCh; i++)    */
	 
	 
	     Buffer[1] = len;   /*  sum channel length  */
	  
	  	 totalsize = totalsize + len + 8;
		 
		 
	 printf("totalsize = 0x%x %d\n",totalsize,totalsize);
	 
	    rc = fwrite(&totalsize, 1, sizeof (totalsize), OutStream);
	    
	    rc = fwrite(&Buffer[0], 1, totalsize, OutStream);
	 
	 }    /* end of (k=0; k<NumBlocks; k++)    */
	 
	 

	    
	 
         
         fclose(OutStream);
	 


}
