
/*
  This  code insert handles histogramming functions
*/

#ifndef V17XXHDRLEN
#define V17XXHDRLEN 4
#endif


/* --------------------------------------------------------------------- */

#ifndef D2VB

#ifdef USETHREADS
void DACQhistogram_data(int ID)
#else
void DACQhistogram_data()
#endif
{
    int len;
    int group, item;
    unsigned int chan;
    unsigned short * eventbuffer;
    unsigned short data, header;
    int i;
    int count, countL, countH;

    unsigned short * eventbufferS;
    unsigned int * eventbufferI;

/*
    len = EventBufferLen;       
    eventbufferS = EventBufferAddr;
    printf("histogram event: length %d\n",len);
    while (len > 0) {printf("0x%x ",*eventbufferS++); len--;}
    printf("\n\n");
*/

    if (*dacq_HistEnable == 0) {return;}   /*  histogramming not enabled  */

    if(*dacq_Trace != 0)  {

#ifdef USEINT
#ifdef USETHREADS
    len = EventBufferLen[ID] * 2;       
    eventbufferI = &EventBuffer[ID][0];
#else
    len = EventBufferLen * 2;     
    eventbufferI = EventBufferAddr;
#endif

    if(*dacq_Trace > 0) printf("histogram event: length %d\n",len);
    if (len == 0) {return;}  
    if(*dacq_Trace > 1)  {
       if (len > 32) len=32;
       while (len > 0) {printf("0x%x ",*eventbufferI++); len--;}
       printf("\n\n");
    }

#endif

#ifdef USESHORT
#ifdef USETHREADS
    len = EventBufferLen[ID];     
    eventbufferS =  &EventBuffer[ID][0];
#else
    len = EventBufferLen;       
    eventbufferS = EventBufferAddr;
#endif

    if(*dacq_Trace > 0) printf("histogram event: length %d\n",len);
    if (len == 0) {return;}
    if(*dacq_Trace > 1) {
       if (len > 64) len=64;
       while (len > 0) {printf("0x%x ",*eventbufferS++); len--;}
       printf("\n\n");
    }

#endif
  
    }

#ifdef USEINT

#ifdef USETHREADS
    len = EventBufferLen[ID] * 2;             /*   len in units of short  */
    eventbuffer = (unsigned short *) &EventBuffer[ID][0];
#else
    len = EventBufferLen * 2;             /*   len in units of short  */
    eventbuffer = (unsigned short *) EventBufferAddr;
#endif

#endif

#ifdef USESHORT

#ifdef USETHREADS
    len = EventBufferLen[ID];             /*   len in units of short  */
    eventbuffer =  &EventBuffer[ID][0];
#else
    len = EventBufferLen;             /*   len in units of short  */
    eventbuffer = EventBufferAddr;
#endif

#endif

    if (len == 0) {return;}     /* empty event */

    if(*dacq_Trace > 1) printf("1: len=%d\n",len);

    while (len > 0)
    {

        header = *eventbuffer++;

        if(*dacq_Trace > 1)printf("2: len=%d; header=0x%x\n",len,header);

        switch ((header >> 14 ) & 3) {

#ifndef EXTENDED
            case 2:        /* extended group format used for digital trace */

            Location = 41;

                count = header & 0x3fff;
                group = *eventbuffer++;

            if(*dacq_Trace > 1)printf("3: %d %d\n",count,group);

#ifdef USEV17XX

/*    for the V1724 module + PHA the first n words of the trace buffer contain Energy, Flags and Timestamp  */

/*   Energy - Item 0  */
/*   Flags - Item = 1 */
/*   TimeTag (MSW)  -  Item = 2 */
/*   TimeTag (LSW)  -  Item = 3 */

/*    for the V1751 module + PSD the first n words of the trace buffer contain Charge and Timestamp  etc */

/*   Charge (long gate) - Item 0  */
/*   Charge (short gate) - Item = 1 */
/*   TimeTag (MSW)  -  Item = 2 */
/*   TimeTag (LSW)  -  Item = 3 */

           if (count > 0) {        /*  required optional item count not present */

              group = group - 256;

              for (item = 0; item < V17XXHDRLEN; item++) {
              
                data = *eventbuffer++;

                if (hist_table[0][0].base != NULL) {
                    chan = (group << 6) + item - hist_table[0][0].offset;
                    if (hist_table[0][0].shift > 0) chan = (chan >> hist_table[0][0].shift);
                    if (chan < hist_table[0][0].size) {hist_table[0][0].base[chan]++;}
                }

                if (group > MAX_GROUP || item > MAX_ITEM) {continue;}
                if (group < MIN_GROUP || item < MIN_ITEM) {continue;}

                if (hist_table[group][item].base != NULL) {
                    chan = data - hist_table[group][item].offset;
                    if (hist_table[group][item].shift > 0) chan = (chan >> hist_table[group][item].shift);
                    if (chan >= hist_table[group][item].size) {chan=0; Stats[BADDATA]++;}
                    hist_table[group][item].base[chan]++; Stats[INC]++;
                }
              }

                count = count - V17XXHDRLEN;
                group = group + 256;

           Location = 411;

               if (count == 0) {len = len - V17XXHDRLEN - 2; break;}

           }
#endif

                if (count == 0) {                   /* allows for longer events   format V2.2 and later */
                    countH = *eventbuffer++;
                    countL = *eventbuffer++;
                    count = (countH << 16) + countL;
                }

           if(*dacq_Trace > 1)printf("4: %d %d\n",count,group);

           Location = 412;
                    item = 0;

                    if (hist_table[0][0].base != NULL) {
                        chan = (group << 6) + item - hist_table[0][0].offset;
                        if (hist_table[0][0].shift > 0) chan = (chan >> hist_table[0][0].shift);
                        if (chan < hist_table[0][0].size) {hist_table[0][0].base[chan]++;}
                    }
           Location = 413;

           if(*dacq_Trace > 1)printf("5: %d %d\n",group,item);
           if(*dacq_Trace > 1)printf("6: %d\n",hist_table[group][item].size);

                    if (hist_table[group][item].base != NULL) {
                       for (i = 0; i < hist_table[group][item].size; i++) {
                           hist_table[group][item].base[i] = 0;
                       }
                    }

            Location = 42;

                    for (i = 0; i < count; i++)
                    {
                        data = *eventbuffer++;

                        if (hist_table[group][item].base != NULL) {
                            chan = i - hist_table[group][item].offset;
                            if (hist_table[group][item].shift > 0) chan = (chan >> hist_table[group][item].shift);
                            if (chan < hist_table[group][item].size) hist_table[group][item].base[chan] = data;
                        }
                    }
                    if (hist_table[group][item].base != NULL) Stats[INC]++;

            Location = 43;

/*    for the GRT4 module the first 4 words of the trace buffer contain  ADC header and Timestamp (in most cases)
      so overwrite these with zero  */

                    for (i = 0; i < (int)hist_table[group][item].offset; i++)
                    {
                        if (hist_table[group][item].base != NULL)  hist_table[group][item].base[i] = hist_table[group][item].shift;
                    }

                len -= (count + 2 + 4);
                if ((header & 0x3fff) == 0) len -= 2;

                break;
#else

             case 2:    /*  extended group format used for normal data */

           Location = 42;

                count = header & 0x3fff;
                group = *eventbuffer++;

                item = 0;
                for (i = 0; i < count; i++)
                {
                    data = *eventbuffer++;

                    if (hist_table[0][0].base != NULL) {
                        chan = (group << 4) + item - hist_table[0][0].offset;
                        if (hist_table[0][0].shift > 0) chan = (chan >> hist_table[0][0].shift);
                        if (chan < hist_table[0][0].size) {hist_table[0][0].base[chan]++;}
                    }

                    if (group > MAX_GROUP || item > MAX_ITEM) {continue;}
                    if (group < MIN_GROUP || item < MIN_ITEM) {continue;}

                    if (hist_table[group][item].base != NULL) {
                        chan = data - hist_table[group][item].offset;
                        if (hist_table[group][item].shift > 0) chan = (chan >> hist_table[group][item].shift);
                        if (chan >= hist_table[group][item].size) {chan=0; Stats[BADDATA]++;}
                        hist_table[group][item].base[chan]++; Stats[INC]++;
                    }
                    item++;
                }

                len -= (count + 2);
                if ((count/2)*2 != count) {eventbuffer++; len--;}   /* for alignment */
                break;

#endif

             case 0:             /*  simple item format */

           Location = 43;

                len--;

                data = *eventbuffer++;
                len--;

                group = header & 255;
                item = (header >> 8) & 63;

                if (hist_table[0][0].base != NULL) {
                    chan = (group << 6) + item - hist_table[0][0].offset;
                    if (hist_table[0][0].shift > 0) chan = (chan >> hist_table[0][0].shift);
                    if (chan < hist_table[0][0].size) {hist_table[0][0].base[chan]++;}
                }

                if (group > MAX_GROUP || item > MAX_ITEM) {continue;}
                if (group < MIN_GROUP || item < MIN_ITEM) {continue;}

                if (hist_table[group][item].base != NULL) {
                    chan = data - hist_table[group][item].offset;
                    if (hist_table[group][item].shift > 0) chan = (chan >> hist_table[group][item].shift);
                    if (chan >= hist_table[group][item].size) {chan=0; Stats[BADDATA]++;}
                    hist_table[group][item].base[chan]++; Stats[INC]++;
                }
                break;
     
             case 1:    /*  standard group format */

           Location = 44;

                count = (header >> 8) & 0x3f;
                group = header & 255;  /*  group number - contains module + adc  */

                item = 0;
                for (i = 0; i < count; i++)
                {
                    data = *eventbuffer++;

                    if (hist_table[0][0].base != NULL) {
                        chan = (group << 6) + item - hist_table[0][0].offset;
                        if (hist_table[0][0].shift > 0) chan = (chan >> hist_table[0][0].shift);
                        if (chan < hist_table[0][0].size) {hist_table[0][0].base[chan]++;}
                    }

                    if (group > MAX_GROUP || item > MAX_ITEM) {continue;}
                    if (group < MIN_GROUP || item < MIN_ITEM) {continue;}

                    if (hist_table[group][item].base != NULL) {
                        chan = data - hist_table[group][item].offset;
                        if (hist_table[group][item].shift > 0) chan = (chan >> hist_table[group][item].shift);
                        if (chan >= hist_table[group][item].size) {chan=0; Stats[BADDATA]++;}
                        hist_table[group][item].base[chan]++; Stats[INC]++;
                    }
                    item++;
                }

                len -= (count + 1);
                if ((count/2)*2 == count) {eventbuffer++; len--;}   /* for alignment */
                break;

             case 3:
             default:
                len = 0;    /*   quit  */
                printf("bad event data - histogramming aborted (%x)\n", header);
                break;
         }
    }
}


/* --------------------------------------------------------------------- */

void DACQ_Init_spectra()
{
   int group, item;

/*    initialise histogram table  */

  for (group = 0; group <= MAX_GROUP; group++)
  {
     for (item = 0; item <= MAX_ITEM; item++)
     {
         hist_table[group][item].base = NULL;
         hist_table[group][item].name[0] = 0;
         hist_table[group][item].size = 0;
         hist_table[group][item].offset = 0;
         hist_table[group][item].shift = 0;
     }
  } 

//   if(*dacq_Trace != 0) 
      printf ("Spectra table initialised\n");

}

/* --------------------------------------------------------------------- */

void DACQ_Get_spectrum(char * spectrumdef)
{

   int group, item, offset, shift;
   int i;
   uint32_t *memaddr;
   uint32_t memlen;
   char specname[32];
#ifdef F2VB
   int label;
#endif

       if(*dacq_Trace != 0)
           printf("DACQ_Get_spectrum %s\n", spectrumdef);

   group = 0; item = 0; offset = 0; shift = 0;   
   sscanf(spectrumdef, "%s %d %d %d %d", &specname[0], &group, &item, &offset, &shift);

#ifdef F2VB

/*
      For FERA + VXI:  histograms for the FERA ADCs are mapped when created so this call is only for VXI ADCs
                       we expect an error for all FERA ADCs 
*/

   if (group > 255) {

       label = sasHistIndex(specname);
       if (label == SAS_ERROR) {
//           printf("Spectrum %s is not known\n", specname);
           return;
       }
       group = label & 255;
       item =  (label >> 8) & 63;
   }

#endif

    memaddr =   (uint32_t *) sasGetSpecMem(specname);
    hist_table[group][item].base = memaddr;

    if (memaddr == NULL) {
        printf("%s Failed to allocate space for spectrum %s\n", VERSION, specname);
        return;
    }

    strcpy (hist_table[group][item].name, &specname[0]);
    memlen  = (unsigned int)    sasGetSpecLen(specname);
    hist_table[group][item].size = memlen >> 2;
    hist_table[group][item].offset = offset;
    hist_table[group][item].shift = shift;

    for (i = 0; i < (int)hist_table[group][item].size; i++) hist_table[group][item].base[i] = 0;

    if(*dacq_Trace != 0)
       printf ("Spectrum %s 0x%x %d (group=%d item=%d offset=%d shift=%d) setup and zeroed\n",
          specname, hist_table[group][item].base, hist_table[group][item].size, group, item, offset, shift);
}

/* --------------------------------------------------------------------- */

void DACQ_Get_spectra(char * spectradefs)
{
   int group, item, offset, shift;
   char specname[32];
   int i, rc;
   uint32_t *memaddr;
   unsigned int memlen;
   int count;

   FILE *idf;

/*    first we should try to open the file containing the spectrum definitions   */

   idf = fopen(spectradefs, "r");
   if (idf == NULL) {
       printf("Unable to open spectrum definition file %s\n", spectradefs);
       return;
   }

/*    now read it   */

   count = 0;

   for (;;)
   {
       rc = fscanf(idf, "%s %i %i %i %i", &specname[0], &group, &item, &offset, &shift);
       if (rc == EOF) break;
       if (rc == 0) continue;

       memaddr = (uint32_t *) sasGetSpecMem(specname);

       if (memaddr == NULL) {
           printf("%s Failed to allocate space for spectrum %s\n", VERSION, specname);
           continue;
       }

       hist_table[group][item].base = memaddr;
       count++;

       strcpy (hist_table[group][item].name, &specname[0]);
       memlen  = (unsigned int)    sasGetSpecLen(specname);
       hist_table[group][item].size = memlen >> 2;
       hist_table[group][item].offset = offset;
       hist_table[group][item].shift = shift;

       for (i = 0; i < (int)hist_table[group][item].size; i++) hist_table[group][item].base[i] = 0;

       if(*dacq_Trace != 0)
         printf ("Spectrum %s 0x%x %d (group=%d item=%d offset=%d shift=%d) setup and zeroed\n",
           specname, hist_table[group][item].base, hist_table[group][item].size, group, item, offset, shift);
    }

    fclose(idf);

    printf("Obtained %d histograms\n", count);
}

/* --------------------------------------------------------------------- */

void DACQ_UnGet_spectra()
{

   int group, item;
   int count;

  count = 0;

  for (group = 0; group <= MAX_GROUP; group++)
  {
          for (item = 0; item <= MAX_ITEM; item++)
          {
             if (hist_table[group][item].base == NULL) continue;
             (void) sasReleaseSpecMem(hist_table[group][item].name, (unsigned char *)hist_table[group][item].base);
             count++;
             hist_table[group][item].base = NULL;
          }
   }

    printf("Released %d histograms\n", count);

   if(*dacq_Trace != 0) printf ("All spectra now released\n");
}

/* --------------------------------------------------------------------- */

void DACQ_UnGet_spectrum(char * specname)
{

   int group, item;

  for (group = 0; group <= MAX_GROUP; group++)
  {
      for (item = 0; item <= MAX_ITEM; item++)
      {
          if (strcmp(specname, hist_table[group][item].name) == 0) {
               if (hist_table[group][item].base != NULL) {
                   (void) sasReleaseSpecMem(hist_table[group][item].name, (unsigned char *)hist_table[group][item].base);
                   hist_table[group][item].base = NULL;
                   if(*dacq_Trace != 0)
                       printf("Spectrum %s now released\n", specname);
               } else {
                   if(*dacq_Trace != 0)
                       printf("Spectrum %s not released because not allocated\n", specname);
               }
               return;       /*  done the job  */
          }
  
       }
   }
}

/* --------------------------------------------------------------------- */

#endif

#ifdef HIST2D

#ifdef USETHREADS
void DACQhistogram2D_data(int ID)
#else
void DACQhistogram2D_data()
#endif
{
   int len;
   unsigned int adc;
   unsigned int group, item, header, count;
   unsigned int xindex, yindex;
   int i, j;

    unsigned short * eventbuffer;

    if (*dacq_HistEnable == 0)  {return;}   /* histogramming not enabled */
    if (Num_hist2D == 0) {return;}          /* no 2D histograms */

#ifdef USEINT

#ifdef USETHREADS
    len = EventBufferLen[ID] * 2;             /*   len in units of short  */
    eventbuffer = (unsigned short *) EventBuffer[ID][0];
#else
    len = EventBufferLen * 2;             /*   len in units of short  */
    eventbuffer = (unsigned short *) EventBufferAddr;
#endif

#endif

#ifdef USESHORT

#ifdef USETHREADS
    len = EventBufferLen[ID];             /*   len in units of short  */
    eventbuffer = EventBuffer[ID][0];
#else
    len = EventBufferLen;             /*   len in units of short  */
    eventbuffer =  EventBufferAddr;
#endif

#endif
      
    if (len == 0) {return;}     /* empty event */

    for (i = 0; i < Num_hist2D; i++)       /* clear hit flags */
    {
         hist2D_table[i].Xhit = 0;
         hist2D_table[i].Yhit = 0;
    }

    while (len > 0)
    {
        header = *eventbuffer++;

        switch ((header >> 14 ) & 3) {
            case 2:        /* extended group format */
                count = header & 0x3fff;
                eventbuffer++;

                eventbuffer += count;
                len -= (count + 2);

                break;

             case 0:             /*  simple item format */
                len--;

                adc = *eventbuffer++;
                len--;

                for (i = 0; i < Num_hist2D; i++)
                {
                    if (header == hist2D_table[i].Xlabel) {hist2D_table[i].Xdata = adc; hist2D_table[i].Xhit = 1; break;}
                    if (header == hist2D_table[i].Ylabel) {hist2D_table[i].Ydata = adc; hist2D_table[i].Yhit = 1; break;}
                }
                break;
     
             case 1:    /*  standard group format */
                count = (header >> 8) & 0x3f;
                group = header & 255; 

                item = 0;
                for (j = 0; j < count; j++)
                {
                    adc = *eventbuffer++;
                    header = (item << 8) + group;

                    for (i = 0; i < Num_hist2D; i++)
                    {
                       if (header == hist2D_table[i].Xlabel) {hist2D_table[i].Xdata = adc; hist2D_table[i].Xhit = 1; break;}
                       if (header == hist2D_table[i].Ylabel) {hist2D_table[i].Ydata = adc; hist2D_table[i].Yhit = 1; break;}
                    }
                    item++;
                }

                len -= (count + 1);
                if ((count/2)*2 == count) {eventbuffer++; len--;}   /* for alignment */
                break;

             case 3:
             default:
                len = 0;    /*   quit  */
                printf("bad event data - histogramming aborted (%x)\n", header);
                break;
         }
    }

       for (i = 0; i < Num_hist2D; i++)      /*  now locate 2D hits; check indexes and histogram if in range */
       {
            if (!(hist2D_table[i].Xhit == 1 && hist2D_table[i].Yhit == 1)) {continue;}
            if (hist2D_table[i].base == NULL) {continue;}
            xindex = (hist2D_table[i].Xdata - hist2D_table[i].Xoffset) >> hist2D_table[i].Xshift;
            if (xindex < 0 || xindex > hist2D_table[i].Xdim) {continue;}
            yindex = (hist2D_table[i].Ydata - hist2D_table[i].Yoffset) >> hist2D_table[i].Yshift;
            if (yindex < 0 || yindex > hist2D_table[i].Ydim) {continue;}
            hist2D_table[i].base[(xindex*hist2D_table[i].Xdim)+yindex]++; Stats[INC2D]++;
       }

}

/* --------------------------------------------------------------------- */

void DACQ_Init_spectra2D()
{
   int i;

/*    initialise histogram table  */

  for (i = 0; i < MAX_HIST2D; i++)
  {
      hist2D_table[i].base = NULL;
      hist2D_table[i].name[0] = 0;
      hist2D_table[i].size = 0;

      hist2D_table[i].Xdim = 0;
      hist2D_table[i].Ydim = 0;

      hist2D_table[i].Xlabel = 0;
      hist2D_table[i].Xoffset = 0;
      hist2D_table[i].Xshift = 0;

      hist2D_table[i].Ylabel = 0;
      hist2D_table[i].Yoffset = 0;
      hist2D_table[i].Yshift = 0;
  } 

   Num_hist2D =  0;

//   if(*dacq_Trace != 0) 
      printf ("2D Spectra table initialised\n");
}

/* --------------------------------------------------------------------- */

void DACQ_Get_spectrum2D(char * spectrumdef)
{

   int xdim, ydim, xlabel, xoffset, xshift, ylabel, yoffset, yshift;
   int i, j;
   unsigned long *memaddr;
   unsigned int memlen;
   char specname[32];

   xdim=0; ydim=0; xlabel=0; xoffset=0; xshift=0; ylabel=0; yoffset=0; yshift=0;
   sscanf(spectrumdef, "%s %d %d %d %d %d %d %d %d", &specname[0], &xdim, &ydim, &xlabel, &xoffset, &xshift, &ylabel, &yoffset, &yshift);

    if(Num_hist2D >= MAX_HIST2D) {
        printf("%s Too many 2D spectra %s\n", VERSION, specname);
        return;
    }

    memaddr = (unsigned long *) sasGetSpecMem(specname);

    if (memaddr == NULL) {
        printf("%s Failed to allocate space for spectrum %s\n", VERSION, specname);
        return;
    }

    i = Num_hist2D;
    Num_hist2D++;

    hist2D_table[i].base = (uint32_t*)memaddr;

    strcpy (hist2D_table[i].name, &specname[0]);
    memlen  = (unsigned int)    sasGetSpecLen(specname);
    hist2D_table[i].size = memlen >> 2;

    hist2D_table[i].Xdim = xdim;
    hist2D_table[i].Ydim = ydim;
    hist2D_table[i].Xlabel = xlabel;
    hist2D_table[i].Xoffset = xoffset;
    hist2D_table[i].Xshift = xshift;
    hist2D_table[i].Ylabel = ylabel;
    hist2D_table[i].Yoffset = yoffset;
    hist2D_table[i].Yshift = yshift;

    for (j = 0; j < hist2D_table[i].size; j++) hist2D_table[i].base[j] = 0;

    if(*dacq_Trace != 0)
       printf ("Spectrum %s 0x%x %d (Xlabel=%d Ylabel=%d) setup and zeroed\n",
          specname, hist2D_table[i].base, hist2D_table[i].size, xlabel, ylabel);
}

/* --------------------------------------------------------------------- */

void DACQ_UnGet_spectra2D()
{

   int i;
   int j;

  j = 0;

  for (i = 0; i < MAX_HIST2D; i++)
  {
       if (hist2D_table[i].base == NULL) continue;
       (void) sasReleaseSpecMem(hist2D_table[i].name, (unsigned char *)hist2D_table[i].base);
       hist2D_table[i].base = NULL;
       j++;
   }

   if(*dacq_Trace != 0) printf ("All 2D spectra now released\n");
}

/* --------------------------------------------------------------------- */

void DACQ_UnGet_spectrum2D(char * specname)
{

   int i;

  for (i = 0; i < MAX_HIST2D; i++)
  {
          if (strcmp(specname, hist2D_table[i].name) == 0) {
               if (hist2D_table[i].base != NULL) {
                   (void) sasReleaseSpecMem(hist2D_table[i].name, (unsigned char *)hist2D_table[i].base);
                   hist2D_table[i].base = NULL;
                   if(*dacq_Trace != 0)
                       printf("Spectrum %s now released\n", specname);
               } else {
                   if(*dacq_Trace != 0)
                       printf("Spectrum %s not released because not allocated\n", specname);
               }
               return;       /*  done the job  */
          }
     }
}

/* --------------------------------------------------------------------- */

#endif


