

#ifndef _HISTOGRAMMING_H
#define _HISTOGRAMMING_H


#define MIN_GROUP 0
#ifndef MAX_GROUP
#define MAX_GROUP 1300
#endif
#define MIN_ITEM  0
#ifndef MAX_ITEM
#define MAX_ITEM  63
#endif

#define SAS_ERROR ERROR




typedef struct hist_table_entry {
    uint32_t size;    /* number of channels  */
    uint32_t offset;  /* first channel */
    uint32_t shift;   /* to compress histogram */
    uint32_t *base;  /* memory address of histogram base  */
    char name [32];       /* spectrum name]  */
} HIST_ENTRY;


HIST_ENTRY hist_table[MAX_GROUP+1][MAX_ITEM+1];

#ifdef HIST2D

#define MAX_HIST2D 2000

typedef struct hist2D_table_entry {
    uint32_t *base;  /* memory address of histogram base  */
    uint32_t size;
    char name [32];       /* spectrum name]  */
    uint16_t Xdim;
    uint16_t Xlabel;
    uint16_t Xoffset;  /* first channel */
    uint16_t Xshift;   /* to compress histogram */
    uint16_t Xdata;
    uint16_t Xhit;     /* X data present */
    uint16_t Ydim;
    uint16_t Ylabel;
    uint16_t Yoffset;  /* first channel */
    uint16_t Yshift;   /* to compress histogram */
    uint16_t Ydata;
    uint16_t Yhit;     /* X data present */
} HIST2D_ENTRY;

HIST2D_ENTRY hist2D_table[MAX_HIST2D];

#endif

int Num_hist2D = 0;

#ifdef USETHREADS
void DACQhistogram_data(int);
#else 
void DACQhistogram_data();
#endif

void DACQ_Init_spectra();
void DACQ_Get_spectrum(char *);
void DACQ_Get_spectra(char *);
void DACQ_UnGet_spectra();
void DACQ_UnGet_spectrum(char *);

#ifdef HIST2D

#ifdef USETHREADS
void DACQhistogram2D_data(int);
#else 
void DACQhistogram2D_data();
#endif

void DACQ_Init_spectra2D();
void DACQ_Get_spectrum2D(char *);
void DACQ_UnGet_spectra2D();
void DACQ_UnGet_spectrum2D(char *);
#endif

#endif
