

/* --------------------------------------------------------------------- */

main (int argc, char **argv)
{

  int i, j;
  int numcounters, maxcounters;
#ifndef WIN32
    int ret;
#endif
#ifdef LYNXOS
   int id;
   int prty1, prty2;
#endif

//   use any argument when running from a login session to prevent output from being
//   directed to the system console

#ifdef WIN32   
    hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
#else
   if (argc == 1) {
       ret = open("/dev/console", O_RDWR);    /* Connect stdin/stdout to console ... */
       (void) dup2(ret, 1);
       (void) dup2(ret, 2);
       (void)setsid();    /* Disconnect from initiator process group ... */
   }
   if (argc == 2) {
       ret = open("/tmp/console", O_RDWR|O_CREAT|O_TRUNC);
       (void) dup2(ret, 1);
       (void) dup2(ret, 2);
       (void)setsid();    /* Disconnect from initiator process group ... */
   }
#endif

   printf ("\n");

#ifdef WIN32
   mypid = GetCurrentProcessId();
#else
   mypid = getpid();
#endif

#ifdef BUILD
   sprintf (message, "%s Data Acquisition Program Release %s Build %s  %s starting\n", VERSION, RELEASE, BUILD, BTIME);
#else
   sprintf (message, "%s Data Acquisition Program Release %s starting\n", VERSION, RELEASE);
#endif
   printf ("%s\n", message);
   msgDefineMessage (0, MSG_C_EB, MSG_S_INFORMATION, NULL, message);

#ifdef BUILD
   sprintf (ID, "%s %s %s %s ", OS, VERSION, RELEASE, BUILD);
#else
   sprintf (ID, "%s %s %s ", OS, VERSION, RELEASE);
#endif

#ifdef USEPTHREAD
   sprintf (message, "Built with pthreads\n");
#else
   sprintf (message, "Built without pthreads\n");
#endif

   printf ("%s\n", message);
   msgDefineMessage (0, MSG_C_EB, MSG_S_INFORMATION, NULL, message);

#ifdef WIN32
    for (ID=0; ID<CORETHREADS+NUMTHREADS; ID++) {
        ThreadInUse[ID] = 0;
    }
    NumThreads = 0;
#endif

#include "netvars.c"

#include "tasks.c"

   exit (0);
}

#include "heartbeat.c"


/* --------------------------------------------------------------------- */
