
/*
    This code insert completes the current data block and sends to the next stage in the DA chain

*/



/* --------------------------------------------------------------------- */
#ifdef USETHREADS
void insert_block_trailer(int ID) 
#else
void insert_block_trailer(int datastream)
#endif
{

/*  insert data block terminator  */

#ifdef USESHORT
    unsigned short *ptr1;
#endif

#ifdef USEINT
    unsigned int *ptr1;
#endif
   
    unsigned short * ptr2;     /* for Exogam format */
    unsigned int * ptr3;     /* for Exogam format */

     ptr1 = &CurrentOutputBuffer[datastream][OutputBufferLen[datastream]];

/*    add end of block marker   */

     switch (Format_Option) {
         case 4:            /*  GREAT/RAW  */

#ifdef USESHORT
            *ptr1++ = (unsigned short) 0xffff;
            *ptr1++ = (unsigned short) 0xffff;
            *ptr1++ = (unsigned short) 0xffff;
            *ptr1++ = (unsigned short) 0xffff;
//            OutputBufferLen[datastream]+=4;
#endif

#ifdef USEINT
            *ptr1++ = (unsigned long) 0xffffffff;
            *ptr1++ = (unsigned long) 0xffffffff;
//            OutputBufferLen[datastream]+=2;
#endif

            break;
         case 1:            /*  exogam  */

            ExogamCurrentOutputBuffer = (unsigned short *) CurrentOutputBuffer;
            ptr2 = &ExogamCurrentOutputBuffer[ExogamOutputBufferLen];

            *ptr2++ = (unsigned short) (EXOGAM_END_BLOCK_TOKEN >> 16) & 0x0000ffff;
            *ptr2++ = (unsigned short) EXOGAM_END_BLOCK_TOKEN & 0x0000ffff;
            ExogamOutputBufferLen +=2;

#ifdef USESHORT
            OutputBufferLen[datastream] = ExogamOutputBufferLen;
#endif
#ifdef USEINT
            OutputBufferLen[datastream] = (ExogamOutputBufferLen + 1) >> 1;
#endif

/*    update some fields in the block header  */

            ptr3 = (unsigned int *) &CurrentOutputBuffer[0];
            ptr3 = (unsigned int *) ((unsigned char *)ptr3 + 20);
            *ptr3++ = Block_Event_Count;      /* block event count */
            *ptr3++ = 0;                    /* checksum - omitted */
            *ptr3++ = ExogamOutputBufferLen - 16;          /* actual data length in shorts */
            break;
         case 2:           /*   MBS  -  rising   */
#ifdef USESHORT
            *ptr1++ = (unsigned short) 0xffff;
            *ptr1++ = (unsigned short) 0xffff;
            OutputBufferLen[datastream]+=2;
#endif

#ifdef USEINT
            *ptr1++ = (unsigned long) 0xffffffff;
            OutputBufferLen[datastream]++;
#endif
            break;
         case 3:            /*  eurogam  */

#ifdef USESHORT
            *ptr1++ = (unsigned short) 0xffff;
            *ptr1++ = (unsigned short) 0x0;
            OutputBufferLen[datastream]+=2;
#endif

#ifdef USEINT
            *ptr1++ = (unsigned long) 0xffff0000;
            OutputBufferLen[datastream]++;
#endif

            break;
      }
}

/* --------------------------------------------------------------------- */

#ifdef USETHREADS
void insert_block_header(int ID) 
#else
void insert_block_header(int datastream)
#endif
{

/*    insert data block header  */
/* note this is not the same as any tape block header */

#ifdef USESHORT
    unsigned short *ptr1;
#endif

#ifdef USEINT
    unsigned int *ptr1;
#endif

    unsigned int * ptr3;     /* for Exogam format */

     Block_Event_Count = 0;
     
     OutputBufferLen[datastream] = 0;
     ptr1 = &CurrentOutputBuffer[datastream][OutputBufferLen[datastream]];

/*    add start of block marker   */

     switch (Format_Option) {
         case 4:            /*  GREAT/RAW  */
            break;
         case 1:            /*  exogam  */
            memcpy (ptr1," EBYEDAT",8);              /* block type */

            ptr3 = (unsigned int *) ((unsigned char *)ptr1 + 8);

            *ptr3++ = Block_Sequence_Number;         /* block sequence number */
            Block_Sequence_Number++;

            *ptr3++ =  0x22061999;                    /* magic number */

#ifndef TIARA
            *ptr3++ =  0x0;                /* source id + destination id */
#else
            *ptr3++ =  0x00020000;                /* source id + destination id */
#endif

            *ptr3++ = Block_Event_Count;      /* block event count */
            *ptr3++ = 0;          /* checksum - omitted */
            *ptr3++ = 0;          /* data length */

            OutputBufferLen[datastream] = 8;           /* length in ints */
            ExogamOutputBufferLen = 16;    /* length in shorts */
            break;
         case 2:           /*   MBS  -  rising   */
            break;
         case 3:
            break;          /*   eurogam  */
      }
}

/* --------------------------------------------------------------------- */

#ifdef USETHREADS
void xfer_block(int ID) 
#else
void xfer_block(int datastream)
#endif
{

   int s1, s2;
   int status;
   int len;

   ULONG stream = 1;

      if (datastream > 1) {return;}                            /*  data transfer not supported */

      if(*dacq_Trace == 1) {
         printf("xfer_block datastream %d:\n", datastream);
      }

      if (datastream == 0 && *dacq_TxEnable == 0) {return;}    /*  data transfer not enabled  */
      if (datastream == 1 && *dacq_Tx2Enable == 0) {return;}    /*  data transfer not enabled  */

   if (XferMode == 4) {     /* MBS */
       (void) transferSetUser(0);
       status = transferStatus();
       if (status == 0) {*dacq_TxEnable = 0;}
   }

//   if (EBXferMode == 4) {     /* MBS */
//       (void) transferSetUser(1);
//       status = transferStatus();
//       if (status == 0) {*dacq_Tx2Enable = 0;}
//   }

      if (datastream == 0 && *dacq_TxEnable == 0) {return;}    /*  data transfer not enabled  */
      if (datastream == 1 && *dacq_Tx2Enable == 0) {return;}    /*  data transfer not enabled  */


   if (xfer_pushDisable) {printf("xfer_block busy\n"); return;}

   xfer_pushDisable = 1;   /*   disable PUSH calls while sending  */

   if (DACQ_State == STOPPED) {
      if (datastream == 0 && *dacq_TxEnable != 0) {
#ifndef GANIL
          (void) transferSetUser(0);
          transferTxWait();   /* wait for any pending transfer */
#else
          if (XferMode == 5) {
              GANILtransferTxWait();   /* wait for any pending transfer */
          } else {
              (void) transferSetUser(0);
              transferTxWait();   /* wait for any pending transfer */
          }
#endif
      }
      if (datastream == 1 && *dacq_Tx2Enable != 0) {
#ifndef GANIL
          (void) transferSetUser(1);
          transferTxWait();   /* wait for any pending transfer */
#else
          if (EBXferMode == 5) {
              GANILtransferTxWait();   /* wait for any pending transfer */
          } else {
              (void) transferSetUser(1);
              transferTxWait();   /* wait for any pending transfer */
          }
#endif
      }
   }

//   if (Block_Event_Count == 0) {xfer_pushDisable = 0; return;}   /*  no data */


#ifndef GANIL

#ifdef USETHREADS
   if (OutputBufferLen[ID] == 0) {
#else
   if (OutputBufferLen[datastream] == 0) {
#endif
        xfer_pushDisable = 0; return;   /* no data */
   }

#else

#ifdef USETHREADS
   if (OutputBufferLen[ID] <= 8) {
#else
   if (OutputBufferLen[datastream] <= 8) {
#endif
        xfer_pushDisable = 0; return;   /* no data */
   }

#endif
 
/*    attempt to send data to tape server     */

#ifdef USETHREADS
      insert_block_trailer(ID);
#else
      insert_block_trailer(datastream);
#endif

#ifdef USEINT
      len = OutputBufferLen[datastream] << 2;   /* bytes */
#endif

#ifdef USESHORT
      len = OutputBufferLen[datastream] << 1;   /* bytes */
#endif

      if(*dacq_Trace == 1) {
          printf("xfer_block #0 datastream %d: for block of length %d bytes\n", datastream, len);
      }

      s1 = 1;
      if (datastream == 0 && *dacq_TxEnable != 0) {
#ifndef GANIL
          (void) transferSetUser(0);
          if (transferTxWait() != 0) Stats[TXWAIT]++;
          s1 = transferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
          if (*dacq_Trace == 1) printf("xfer_block #1 datastream %d: transferTxData returned status = %d\n", datastream, datastream, s1);
          if (s1 != 0) Stats[TXERR]++;
          if (DACQ_State == STOPPED) transferTxWait();
#else
          if (XferMode == 5) {
              if (GANILtransferTxWait() != 0) Stats[TXWAIT]++;
              s1 = GANILtransferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
              if (*dacq_Trace == 1) printf("xfer_block #2 datastream %d: GANILtransferTxData returned status = %d\n", datastream, s1);
              if (s1 != 0) Stats[TXERR]++;
              if (DACQ_State == STOPPED) GANILtransferTxWait();
          } else {
              (void) transferSetUser(0);
              if (transferTxWait() != 0) Stats[TXWAIT]++;
              s1 = transferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
              if (*dacq_Trace == 1) printf("xfer_block #3 datastream %d: transferTxData returned status = %d\n", datastream, s1);
              if (s1 != 0) Stats[TXERR]++;
              if (DACQ_State == STOPPED) transferTxWait();
          }
#endif
      }

      s2 = 1;
      if (datastream == 1 && *dacq_Tx2Enable != 0) {
#ifndef GANIL
          (void) transferSetUser(1);
          if (transferTxWait() != 0) Stats[TX2WAIT]++;
          s2 = transferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
          if (*dacq_Trace == 1) printf("xfer_block #4 datastream %d: transferTxData returned status = %d\n", datastream, s2);
          if (s2 != 0) Stats[TX2ERR]++;
          if (DACQ_State == STOPPED) transferTxWait();
#else
          if (EBXferMode == 5) {
             if (GANILtransferTxWait() != 0) Stats[TX2WAIT]++;
             s2 = GANILtransferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
             if (*dacq_Trace == 1) printf("xfer_block #5 datastream %d: GANILtransferTxData returned status = %d\n", datastream, s2);
             if (s2 != 0) Stats[TX2ERR]++;
             if (DACQ_State == STOPPED) GANILtransferTxWait();
          } else {
             (void) transferSetUser(1);
             if (transferTxWait() != 0) Stats[TX2WAIT]++;
             s2 = transferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
             if (*dacq_Trace == 1) printf("xfer_block #6 datastream %d: transferTxData returned status = %d\n", datastream, s2);
             if (s2 != 0) Stats[TX2ERR]++;
             if (DACQ_State == STOPPED) transferTxWait();
          }
#endif
      }

      if (s1 == 0) {
         Stats[TXBUFFERS]++;
         Stats[TXTOTALCOUNT] += len;
      }

      if (s2 == 0) {
         Stats[TX2BUFFERS]++;
         Stats[TX2TOTALCOUNT] += len;
      }

/*    get next output buffer    */

      CurrentOutputBufferNum = (CurrentOutputBufferNum + 1) & ((NUMOVERLAPS*NUMTHREADS) - 1);
      CurrentOutputBuffer[datastream] = OutputBufferAddr[CurrentOutputBufferNum + (datastream*(NUMOVERLAPS*NUMTHREADS))];
      OutputBufferLen[datastream] = 0;


#ifdef USETHREADS
     insert_block_header(ID);
#else
     insert_block_header(datastream);
#endif

      xfer_pushDisable = 0;   /*   allow PUSH calls again  */
}

/* --------------------------------------------------------------------- */


#ifdef USETHREADS
void xfer_push(int ID) 
#else
void xfer_push(int datastream)
#endif
{

   int status;
   int PushEnable;
#ifdef GANIL
   int len;
   int s1, s2;
#endif

   ULONG stream = 1;

      if (datastream > 1) {return;}                            /*  data transfer not supported */

      readNetInt("DACQ_PushEnable", 0, 1, &PushEnable);
      if (PushEnable <= 0) return;                               /*   not enabled  */

      if(*dacq_Trace == 1) {
         printf("xfer_push datastream %d:\n", datastream);
      }

      if (datastream == 0 && *dacq_TxEnable == 0) {return;}    /*  data transfer not enabled  */
      if (datastream == 1 && *dacq_Tx2Enable == 0) {return;}    /*  data transfer not enabled  */

#ifndef GANIL

      if (DACQ_State == STOPPED) return;      /*   not while STOPPED  */

   if (XferMode == 4) {     /* MBS */
       (void) transferSetUser(0);
       status = transferStatus();
       if (status == 0) {*dacq_TxEnable = 0;}
   }

//   if (EBXferMode == 4) {     /* MBS */
//       (void) transferSetUser(1);
//       status = transferStatus();
//       if (status == 0) {*dacq_Tx2Enable = 0;}
//   }

      if (datastream == 0 && *dacq_TxEnable == 0) {return;}    /*  data transfer not enabled  */
      if (datastream == 1 && *dacq_Tx2Enable == 0) {return;}    /*  data transfer not enabled  */

      if (datastream == 0) {
          (void) transferSetUser(0);
          if (transferState()) return;            /*  already something sending   */
      }

      if (datastream == 1) {
          (void) transferSetUser(1);
          if (transferState()) return;            /*  already something sending   */
      }

      if(*dacq_Trace == 1) {
         printf("xfer_push datastream %d: calls xfer_block\n", datastream);
      }

      xfer_block(datastream);

#else
      if (!(Xfer_Option == 5 || EBXfer_Option == 5)) return;  /*  only used by GANIL protocol  */

//    GANIL transfer protocol requires that we always send to keep connection alive

      if (GANILtransferState()) return;      /*  already something sending   */

/*    attempt to send data to tape server     */

#ifdef USETHREADS
     insert_block_trailer(int ID);
#else
     insert_block_trailer(datastream);
#endif

#ifdef USEINT
      len = OutputBufferLen[datastream] << 2;   /* bytes */
#endif

#ifdef USESHORT
      len = OutputBufferLen[datastream] << 1;   /* bytes */
#endif

      if (Block_Event_Count == 0) len = 0;  /* special case if no events   */

      if(*dacq_Trace == 1)
         printf("xfer_block #7 datastream %d: calling GANILtransferTxData- address = 0x%x; length = %d\n", datastream, CurrentOutputBuffer, len);

      s1 = 1;
      if (Xfer_Option == 5) {
      
              if (GANILtransferTxWait() != 0) Stats[TXWAIT]++;
              s1 = GANILtransferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
              if (*dacq_Trace == 1) printf("xfer_block #8 datastream %d: GANILtransferTxData returned status = %d\n", datastream, s1);
              if (len > 0 && s1 != 0) Stats[TXERR]++;
      }

      s2 = 1;
      if (EBXfer_Option == 5) {

             if (GANILtransferTxWait() != 0) Stats[TXWAIT]++;
             s2 = GANILtransferTxData ((char *) CurrentOutputBuffer[datastream] , stream, len); 
             if (*dacq_Trace == 1) printf("xfer_block #9 datastream %d: GANILtransferTxData returned status = %d\n", datastream, s2);
             if (len > 0 && s2 != 0) Stats[TXERR]++;
      }

      if (s1 == 0 || s2 == 0) {
         if (len > 0) {
             Stats[TXBUFFERS]++;
             Stats[TXTOTALCOUNT] += len;
         }
      }

/*    get next output buffer    */

      CurrentOutputBufferNum = (CurrentOutputBufferNum + 1) & ((NUMOVERLAPS*NUMTHREADS) - 1);
      CurrentOutputBuffer[datastream] = OutputBufferAddr[CurrentOutputBufferNum + (datastream*(NUMOVERLAPS*NUMTHREADS))];
      OutputBufferLen[datastream] = 0;

#ifdef USETHREADS
     insert_block_header(int ID);
#else
     insert_block_header(datastream);
#endif

#endif
}

/* --------------------------------------------------------------------- */
