#include "common.h"

void bcopyBytes (char  *source, char  *destination, int   nbytes);
void bcopyWords (char  *source, char  *destination, int   nwords);
void bcopyLongs (char  *source, char  *destination, int   nlongs);

char *vme_map (unsigned int addr, unsigned int wsiz, unsigned int am);
int vme_rel(unsigned int laddr, unsigned int wsiz);
char *vmeMapA16   (unsigned int addr, unsigned int wsiz);
char *vmeMapA16D8 (unsigned int addr, unsigned int wsiz);
char *vmeMapA24   (unsigned int addr, unsigned int wsiz);
char *vmeMapA32   (unsigned int addr, unsigned int wsiz);
char *vmeMapA32S  (unsigned int addr, unsigned int wsiz);

STATUS taskLock(void);
STATUS taskUnlock(void);
STATUS taskDelay (int ticks);

STATUS rmAddressShare (int slot, char *rmadd, int size, int space);
STATUS rmShortAddressShare (int slot, char *rmsadd);
char *rmAddress (int slot);
char *rmShortAddress (int slot);
char *rmMappedAddress (int slot, int offset);
char *rmMappedShortAddress (int slot, int offset);
void rmAddressesDump(int max);

#define MAX_SCALAR_ARRAY_LEN 504
#define MAX_STRING_ARRAY_LEN 63
#define MAX_STR_LEN 63
#define MAX_BLOCK_LEN (MAX_STRING_ARRAY_LEN*(MAX_STR_LEN+1))

STATUS assignNetChar (char *name, int index, int len, char val);
STATUS assignNetUChar (char *name, int index, int len, UCHAR val);
STATUS assignNetInt (char *name, int index, int len, int val);
STATUS assignNetUInt (char *name, int index, int len, UINT val);
STATUS assignNetShort (char *name, int index, int len, INT16 val);
STATUS assignNetUShort (char *name, int index, int len, UINT16 val);
STATUS assignNetLong (char *name, int index, int len, INT32 val);
STATUS assignNetULong (char *name, int index, int len, UINT32 val);
STATUS assignNetFloat (char *name, int index, int len, float val);
STATUS assignNetDouble (char *name, int index, int len, double val);
STATUS assignNetString (char *name, int index, int len, char *val);
STATUS assignNetBlock (char *name, int index, int len, char val);
STATUS readNetChar (char *name, int index, int len, char *val);
STATUS readNetUChar (char *name, int index, int len, UCHAR *val);
STATUS readNetInt (char *name, int index, int len, int *val);
STATUS readNetUInt (char *name, int index, int len, UINT *val);
STATUS readNetShort (char *name, int index, int len, INT16 *val);
STATUS readNetUShort (char *name, int index, int len, UINT16 *val);
STATUS readNetLong (char *name, int index, int len, INT32 *val);
STATUS readNetULong (char *name, int index, int len, UINT32 *val);
STATUS readNetFloat (char *name, int index, int len, float *val);
STATUS readNetDouble (char *name, int index, int len, double *val);
STATUS readNetString (char *name, int index, int len, char *val);
STATUS readNetBlock (char *name, int index, int len, char *val);

STATUS releaseNetVar (char *name);
STATUS freeNetVar (char *name);

void *getNetVarMem (char *name);
STATUS freeNetVarMem (char *name, void *memy);

STATUS assignNetIntMem (void *memy, int index, int len, int val);
STATUS assignNetStringMem (void *memy, int index, int len, char *val);
STATUS assignNetBlockMem (void *memy, int index, int len, char *val);
STATUS readNetIntMem (void *memy, int index, int len, int *val);
STATUS readNetStringMem (void *memy, int index, int len, char *val);
STATUS readNetBlockMem (void *memy, int index, int len, char *val);

int  *getNetIntMem (char *name);
int  *getNetIntArrayMem (char *name, int index);
int  *getNetIntIndexMem (void *mem, int index);
INT16  *getNetShortMem (char *name);
INT16  *getNetShortArrayMem (char *name, int index);
INT16  *getNetShortIndexMem (void *mem, int index);
char *getNetStringMem (char *name);
char *getNetStringArrayMem (char *name, int index);
char *getNetStringIndexMem (void *mem, int index);
char *getNetBlockMem (char *name);
char *getNetBlockArrayMem (char *name, int index);
char *getNetBlockIndexMem (void *mem, int index);
