
#    Note:  This is loaded into the namespace  FEBEX_ADCSync

# variable started 0

if {![info exists started]} {variable started 0}

global Options
global env

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0
    variable DebugFlag 0

    variable JS ""
    

  global ModuleMenu
  global LinkMenu
  global BoardMenu
  global ChannelMenu
  
  global Options
  
        global FEBEXmodule
        global FEBEXlink
        global FEBEXboard
        global FEBEXchannel 
    
        variable allmodules 0
        variable alllinks 0
        variable allboards 0
     
        variable CModule 0
        variable CLink 0
        variable CBoard 0
        
   variable Status {idle idle idle idle idle idle idle idle idle idle}
   variable Status0 "unknown"


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
       
        variable CModule
        variable CLink
        variable CBoard
        
        variable allmodules
        variable alllinks
        variable allboards
        
        variable Status
        variable Status0

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "Module=$CModule; Link=$CLink; Board=$CBoard"
        InsertLog "allmodules=$allmodules; alllinks=$alllinks; allboards=$allboards"  global ModuleMenu
  global LinkMenu
  global BoardMenu
  global ChannelMenu
  
  global Options
       
        InsertLog "Status0=$Status0 ; Status=$Status"
   }
     
   proc UpdateModule {} {}
   
   proc do_step0 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status0
  
      set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_status} m0]
      if {$z != 0} {
         set Status0  "$m0"
      } else {
         set m0 [format 0x%x [expr $m0 & 15]]
         set Status0 "Status=$m0"
      }
   }
   
   proc do_step1 {} {   
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 0
   }
   
   proc do_step2 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 1
      set z [catch {WriteFEBEX4ARegister $CLink $CBoard 0 adcclk_sync 1} m1]
      if {$z != 0} {
         set Status [lreplace $Status $SBit $SBit "$m1"]
      } else {
         set Status [lreplace $Status $SBit $SBit "OK"]
         set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_status} m2]
         if {$z == 0} {
             set m2 [format 0x%x [expr $m2 & 15]]
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
         } else {
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
         }
      }
   }
   
   proc do_step3 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 2
      set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_status} m1]
      if {$z != 0} {
         set Status [lreplace $Status $SBit $SBit "$m1"]
      } else {
         set m1 [format 0x%x [expr $m1 & 15]]
         set Status [lreplace $Status $SBit $SBit "OK - Status=$m1"]
      }
   }
   
   proc do_step4 {} {}
   
   proc do_step5 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 4
      set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_status} m1]
      if {$z != 0} {
         set Status [lreplace $Status $SBit $SBit "$m1"]
      } else {
         set m1 [format 0x%x [expr $m1 & 15]]
         set Status [lreplace $Status $SBit $SBit "OK - Status=$m1"]
      }
   }
   
   proc do_step6 {} {variable Status; set SBit 5; set Status [lreplace $Status $SBit $SBit "not implemented yet"]}
   
   proc do_step7 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 6
      set z [catch {WriteFEBEX4ARegister $CLink $CBoard 0 adcclk_expld 1} m1]
      if {$z != 0} {
         set Status [lreplace $Status $SBit $SBit "$m1"]
      } else {
         set Status [lreplace $Status $SBit $SBit "OK"]
         set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_status} m2]
         if {$z == 0} {
             set m2 [format 0x%x [expr $m2 & 15]]        
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
         } else {
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
         }
      }
   }
   
   proc do_step8 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 7
      set z [catch {WriteFEBEX4ARegister $CLink $CBoard 0 adcclk_gtx 1} m1]
      if {$z != 0} {
         set Status [lreplace $Status $SBit $SBit "$m1"]
      } else {
         set Status [lreplace $Status $SBit $SBit "OK"]
         set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_status} m2]
         if {$z == 0} {
             set m2 [format 0x%x [expr $m2 & 15]]      
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
         } else {
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
         }
      }
   }
   
  proc do_step9 {} {
      variable CModule
      variable CLink
      variable CBoard
      variable Status
  
      set SBit 8
      set z [catch {WriteFEBEX4ARegister $CLink $CBoard 0 adcclk_cap 1} m1]
      if {$z != 0} {
         set Status [lreplace $Status $SBit $SBit "rc=$z; $m1"]
         return
      } else {
         set Status1 [lreplace $Status $SBit $SBit "OK"]
         set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_tsH} m2]
         if {$z != 0} {
             set Status [lreplace $Status $SBit $SBit "rc=$z; $m2"]
             return
         } else {
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2"]
             set tsH $m2
         }
         set z [catch {ReadFEBEX4ARegister $CLink $CBoard 0 adcclk_tsL} m3]
         if {$z != 0} {
             set Status [lreplace $Status $SBit $SBit "rc=$z; $m3"]
             return
         } else {
             set Status [lreplace $Status $SBit $SBit "OK - Status=$m2 $m3"]
             set tsL $m3
         }
      }
      
      set Status [lreplace $Status $SBit $SBit "OK - TS= $tsH $tsL [format "0x16%x" [expr ($tsH << 32) + $tsL]]"]
     
   }
   
   
   proc do_execute {n} {
      variable Status
   
      switch  $n  {
          ButtonB0 {do_step0}
          ButtonB1 {do_step1}
          ButtonB2 {do_step2}
          ButtonB3 {do_step3}         
          ButtonB4 {do_step4}
          ButtonB5 {do_step5}
          ButtonB6 {do_step6}
          ButtonB7 {do_step7}
          ButtonB8 {do_step8}
          ButtonB9 {do_step9}

          default  {InsertLog "unexpected switch in do_execute:  $n"} 
      }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable allmodules
        variable alllinks
        variable allboards
        variable CModule
        variable CLink
        variable CBoard

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]
           set i [second [lindex $cgidata 1]]
           set vl [third [lindex $cgidata 1]]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}
                
                HELP     {variable HelpTopic; set HelpTopic Help; do_help}                
                
                   MODULE     {SelectFEBEXModule $i; UpdateModule}
                   ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                   LINK     {SelectFEBEXLink $i; UpdateModule}
                   ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                   BOARD     {SelectFEBEXBoard $i; UpdateModule}
                   ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}
                   
                   CMODULE    {set CModule $i}
                   CLINK      {set CLink $i}
                   CBOARD     {set CBoard $i}
                   
                   ADCSync    {do_execute $i}
      
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
       
    }

     set html ""


}  ;# end of if {$started == 0}

