
# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   do_click

}


if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0
    variable DebugFlag 0

    variable JS ""
    
    set NumChans 16
    
    set JS ""
    
    
        variable FEBEXmodule
        variable FEBEXlink
        variable FEBEXboard
        variable FEBEXchannel
        
        variable Link 0
        variable Board 0
        
        variable allmodules 0
        variable alllinks 0
        variable allboards 0

   variable index 0
       
       set Link $::FEBEX::link
       set Board $::FEBEX::board
       
      variable filelist {undefined}
      variable filename [first $filelist]

       
   proc show_variables {} {
      
        global MIDAS_DataAcquisitionControlServer_Exists
        variable LogFlag
        variable ShowLogFlag
        variable alllinks
        variable allboards
        variable filename

        InsertLog "MIDAS_DataAcquisitionControlServer_Exists=$MIDAS_DataAcquisitionControlServer_Exists"

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "alllinks=$alllinks; allboards=$allboards"
        InsertLog "filename = $filename"
 
   }
   
      proc do_BoardName {w} {
        global env
        variable filelist
        variable filename

        set FirmwareDir [file join $env(MIDASBASE) TclHttpd Html FEBEX FirmWare [second [split $w _]]]

        set z [catch {file isdirectory $FirmwareDir} m]
        if {$z != 0 || $m == 0} {
            Alert "Unable to access $FirmwareDir or $FirmwareDir is not a directory"
            return
        }

        set arg "-name \"*.bit\""
        set z [catch {eval exec find $FirmwareDir $arg} m]

        if {$z != 0} {
            Alert "Unable to obtain firmware files: $m"
            return
        }

        set filelist {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend filelist $item
        }

        if {[llength $filelist] == 0} {set filename "undefined"} else {set filename [first $filelist]}

     }

   
     proc do_FileName {w} {
          variable filename

          set filename $w
     }
     
     proc UpdateModule {} {}
     
     
     proc do_Program {w} {

          variable filename
          
       if {$w == 0} {
       
             Confirm UPDATEFIRMWARE "Load firmware $filename for flash memory **** using **** into ?????????"
       } else {
       
             set cmd "./UpdateFirmware.bin $filename"
             InsertLog "executing $cmd\\n"
             set z [catch {eval exec $cmd} m]
             InsertLog "Action completed with rc = $z and response \\n$m"
             if {$z == 0} {
                 InsertLog "User FPGA reload requested\\n"
             }
             Alert "finished"
       }

     }
   
       
   proc do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable allmodules
        variable alllinks
        variable allboards

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
        
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}
                
                MODULE     {SelectFEBEXModule $i; UpdateModule}
                ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                LINK     {SelectFEBEXLink $i; UpdateModule}
                ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                BOARD     {SelectFEBEXBoard [lindex $w 1]; UpdateModule; do_BoardName [lindex $w 1]}
                ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}

                FILE    {do_FileName [lindex $w 1]}
                PROGRAM {do_Program 0}
                CONFIRM {do_Program 1}

                MainLog {}
                undefined {}
                default  {InsertLog "unexpected cgi data: [lindex $w 0]  $cgidata"}
            }
         }
       }
    }    ;#  end of do_click

}  ;# end of if {$started == 0}
